
#pragma once

#include "AlivcDef.h"
#include "AlivcNetworkManager.h"
#include "qevent.h"
#include "sdk_headers/AliMediaDownloader.h"
#include "ui_AlivcDownloadPrepareDlg.h"
#include <QDialog>
#include <memory>

using namespace alivc_player;

class AlivcDownloadPrepareDlg : public QDialog, public IAVDListener {
    Q_OBJECT
public:
    AlivcDownloadPrepareDlg(QWidget *parent);
    ~AlivcDownloadPrepareDlg();
    DownloadSourceInfo GetDownloadSourceInfo();
    void CheckAuthInfo();

    //IAVDListener
    void onPrepared(AliMediaDownloader *downloader, AVPMediaInfo *mediaInfo) override;
    void onError(AliMediaDownloader *downloader, AVPErrorModel *errorModel) override;
    void onDownloadingProgress(AliMediaDownloader *downloader, int percent) override;
    void onProcessingProgress(AliMediaDownloader *downloader, int percent) override;
    void onCompletion(AliMediaDownloader *downloader) override;

signals:
    void SgnPrepared();
    void SgnError(QString error);

private slots:
    void on_btnDone_clicked();
    void on_btnStsDownload_clicked();
    void on_btnPlayAuthDownload_clicked();
    void on_btnGetStsInfo_clicked();
    void on_btnGetPlayAuthInfo_clicked();
    void on_btnPrepare_clicked();
    void on_editVid_textChanged();

    void OnPreparedUI();
    void OnErrorUI(QString error);

private:
    void InitEvent();
    void EnableStsControls(bool enable);
    void EnablePlayAuthControls(bool enable);
    std::unique_ptr<Ui::AlivcDownloadPrepareDlg> ui;
    AlivcAppServerBaseAPI *mAppServerApi = nullptr;
    AliMediaDownloader *mMediaDownloader = nullptr;
    AVPMediaInfo mMediaInfo;
};
