#include "AlivcNetworkManager.h"

const static QString GetVideoListUrl = "https://alivc-demo.aliyuncs.com/vod/getRecommendVideoList?token=eyJhbGciOiJIUzI1NiJ9.eyJqdGkiOiI1NDMyMDkiLCJpYXQiOjE1OTExNTAwMDUsInN1YiI6IntcInVzZUlkXCI6XCI1NDMyMDlcIn0iLCJleHAiOjE1OTM3NDIwMDV9.NuBNTE4rK2gELOYRBY4KcXjLxWKbQIzGk_JUGEifBqA&pageIndex=1&pageSize=10";
const static QString GetStsInfoUrl = "https://alivc-demo.aliyuncs.com/demo/getSts";

AlivcAppServerBaseAPI::AlivcAppServerBaseAPI(QObject *parent)
    : QObject(parent)
{
  connect(&mNetworkAcessManager, &QNetworkAccessManager::finished, this, &AlivcAppServerBaseAPI::OnHttpRequestFinished);
}

AlivcAppServerBaseAPI::~AlivcAppServerBaseAPI()
{
  mNetworkAcessManager.disconnect();
}

void AlivcAppServerBaseAPI::Get(const QString& url, std::function<void(int, QByteArray)> completionFunc)
{
  mCompletionFunc = completionFunc;
  mHttpRequest.setUrl(QUrl(url));
  QSslConfiguration config;
  config.setPeerVerifyMode(QSslSocket::VerifyNone);
  config.setProtocol(QSsl::TlsV1_0);
  mHttpRequest.setSslConfiguration(config);
  mNetworkAcessManager.get(mHttpRequest);
}

void AlivcAppServerBaseAPI::Post(const QString& url, const QByteArray &data, std::function<void(int, QByteArray)> completionFunc)
{
  mCompletionFunc = completionFunc;
  mHttpRequest.setUrl(QUrl(url));
  mNetworkAcessManager.post(mHttpRequest, data);
}

void AlivcAppServerBaseAPI::GetVideoList(std::function<void(int, QByteArray)> completionFunc)
{
  Get(GetVideoListUrl, completionFunc);
}

void AlivcAppServerBaseAPI::GetStsInfo(std::function<void(int, QByteArray)> completionFunc)
{
  Get(GetStsInfoUrl, completionFunc);
}

void AlivcAppServerBaseAPI::OnHttpRequestFinished(QNetworkReply *reply)
{
  int statusCode = reply->attribute(QNetworkRequest::HttpStatusCodeAttribute).toInt();
  if (reply->error() == QNetworkReply::NoError)
  {
    mCompletionFunc(statusCode, reply->readAll());
  }
  else
  {
    mCompletionFunc(statusCode, reply->readAll());
  }
  reply->deleteLater();
}
