#ifndef AlivcLivePlayr_List_Model_h
#define AlivcLivePlayr_List_Model_h

#include <QAbstractTableModel>

enum VideoInfoItem
{
  VideoInfoItemVideoIdRow,
  VideoInfoItemTitleRow,
  VideoInfoItemSizeRow,
  VideoInfoItemDurationRow,
  VideoInfoItemCreateTimeRow,
  VideoInfoItemTotalCount,
};

struct AlivcVideoInfo
{
  QString status;
  QString storageLocation;
  QString title;
  QString creationTime;
  QString videoId;
  QString modifyTime;
  QString modificationTime;
  unsigned long long duration;
  QString createTime;
  unsigned long long size;
  QString coverURL;
};

class AlivcPlayListModel : public QAbstractTableModel
{
  Q_OBJECT

public:
  AlivcPlayListModel(QObject *parent = nullptr);
  ~AlivcPlayListModel();

  virtual int rowCount(const QModelIndex &parent) const;

  virtual int columnCount(const QModelIndex &parent) const;

  virtual QVariant data(const QModelIndex &index, int role) const;

  virtual QVariant headerData(int section, Qt::Orientation orientation, int role) const;

  void AddVideoInfo(AlivcVideoInfo& info);

  void GetVideoInfoByIndex(int index, AlivcVideoInfo& videoInfo);

private:
  std::vector<AlivcVideoInfo> mVideoInfos;
};

#endif //AlivcLivePlayr_List_Model_h