#include "AlivcPlayerMpsDlg.h"
#include "QJsonDocument"
#include <windows.h>


AlivcPlayerMpsDlg::AlivcPlayerMpsDlg(QWidget *parent) : QDialog(parent), ui(new Ui::AlivcPlayerMpsDlg)
{
    setWindowFlags(windowFlags() & ~Qt::WindowContextHelpButtonHint);
    ui->setupUi(this);
}

AlivcPlayerMpsDlg::~AlivcPlayerMpsDlg()
{
    if (mGetMpsInfoApi) {
        delete mGetMpsInfoApi;
        mGetMpsInfoApi = nullptr;
    }
}

AlivcMpsInfo AlivcPlayerMpsDlg::GetMpsInfo()
{
    AlivcMpsInfo ret;
    ret.vid = ui->editVid->text();
    ret.accessKeyId = ui->editAccessKeyId->text();
    ret.accessKeySecret = ui->editAccessKeySecret->text();
    ret.expiration = ui->editExpiration->text();
    ret.securityToken = ui->editSecurityToken->text();
    ret.region = ui->editRegion->text();
    ret.authInfo = ui->editAuthInfo->text();
    ret.playDomain = ui->editPlayDomain->text();
    ret.hlsUriToken = ui->editHlsUriToken->text();
    return ret;
}

void AlivcPlayerMpsDlg::on_btnGetMpsInfo_clicked()
{
    if (mGetMpsInfoApi == nullptr) {
        mGetMpsInfoApi = new AlivcAppServerBaseAPI(this);
    }
    mGetMpsInfoApi->Get(ui->editMpsUrl->text(), [&](int statusCode, QByteArray data) {
        QJsonParseError jsonError;
        QJsonDocument jsonDocument = QJsonDocument::fromJson(data, &jsonError);
        if (jsonError.error != QJsonParseError::NoError || !jsonDocument.isObject()) {
            return;
        }

        QVariantMap result = jsonDocument.toVariant().toMap();
        QVariant dataValue = result["data"];
        QVariantMap dataMap = dataValue.toMap();
        ui->editVid->setText(dataMap["MediaId"].toString());
        ui->editHlsUriToken->setText(dataMap["HlsUriToken"].toString());
        ui->editRegion->setText(dataMap["RegionId"].toString());
        ui->editAuthInfo->setText(dataMap["authInfo"].toString());
        QVariantMap akInfoMap = dataMap["AkInfo"].toMap();
        ui->editSecurityToken->setText(akInfoMap["SecurityToken"].toString());
        ui->editAccessKeyId->setText(akInfoMap["AccessKeyId"].toString());
        ui->editAccessKeySecret->setText(akInfoMap["AccessKeySecret"].toString());
        ui->editExpiration->setText(akInfoMap["Expiration"].toString());
    });
}

void AlivcPlayerMpsDlg::on_btnDone_clicked()
{
    accept();
}
