#include "AlivcPlayerStsDlg.h"
#include "QJsonDocument"
#include <windows.h>


AlivcPlayerStsDlg::AlivcPlayerStsDlg(QWidget *parent) : QDialog(parent), ui(new Ui::AlivcPlayerStsDlg)
{
    setWindowFlags(windowFlags() & ~Qt::WindowContextHelpButtonHint);
    ui->setupUi(this);
}

AlivcPlayerStsDlg::~AlivcPlayerStsDlg()
{
    if (mGetStsInfoApi) {
        delete mGetStsInfoApi;
        mGetStsInfoApi = nullptr;
    }
}

AlivcStsInfo AlivcPlayerStsDlg::GetStsInfo()
{
    AlivcStsInfo ret;
    ret.accessKeyId = ui->editAccessKeyId->text();
    ret.accessKeySecret = ui->editAccessKeySecret->text();
    ret.expiration = ui->editExpiration->text();
    ret.securityToken = ui->editSecurityToken->text();
    ret.region = ui->editRegion->text();
    return ret;
}

void AlivcPlayerStsDlg::on_btnGetStsInfo_clicked()
{
    if (mGetStsInfoApi == nullptr) {
        mGetStsInfoApi = new AlivcAppServerBaseAPI(this);
    }
    mGetStsInfoApi->Get(ui->editStsUrl->text(), [&](int statusCode, QByteArray data) {
        QJsonParseError jsonError;
        QJsonDocument jsonDocument = QJsonDocument::fromJson(data, &jsonError);
        if (jsonError.error != QJsonParseError::NoError || !jsonDocument.isObject()) {
            return;
        }

        QVariantMap result = jsonDocument.toVariant().toMap();
        QVariant dataValue = result["data"];
        QVariantMap dataMap = dataValue.toMap();
        ui->editAccessKeyId->setText(dataMap["accessKeyId"].toString());
        ui->editAccessKeySecret->setText(dataMap["accessKeySecret"].toString());
        ui->editSecurityToken->setText(dataMap["securityToken"].toString());
        ui->editExpiration->setText(dataMap["expiration"].toString());
    });
}

void AlivcPlayerStsDlg::on_btnDone_clicked()
{
    accept();
}
