#include "AlivcPlayerMainDlg.h"
#include <QtWidgets/QApplication>
#include <QDesktopWidget>
#include <QApplication>
#include <windows.h>
#include <signal.h>
#include <stdlib.h>
#include <Dbghelp.h>
#include <stdio.h>
#include <time.h>

void signal_abort_handler(int signal)
{
  time_t  nowtime;
  time(&nowtime);
  struct tm *pTime = localtime(&nowtime);
  char szFile[128] = { 0 };

  sprintf(szFile, "Alivc_Player_Demo_%4d_%02d_%02d_%02d_%02d_%02d.dmp", pTime->tm_year + 1900, pTime->tm_mon + 1, pTime->tm_mday, pTime->tm_hour, pTime->tm_min, pTime->tm_sec);
  HANDLE hFile = CreateFileA(szFile, GENERIC_READ | GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);

  if (hFile != INVALID_HANDLE_VALUE)
  {
    MINIDUMP_TYPE flags = (MINIDUMP_TYPE)(MiniDumpWithFullMemory | MiniDumpWithFullMemoryInfo | MiniDumpWithHandleData | MiniDumpWithUnloadedModules | MiniDumpWithThreadInfo);
    BOOL bOK = MiniDumpWriteDump(GetCurrentProcess(), GetCurrentProcessId(), hFile, flags, 0, NULL, NULL);
    CloseHandle(hFile);
  }

  return;
}

LONG WINAPI exception_handler(struct _EXCEPTION_POINTERS *pExceptionInfo)
{
  LONG ret = EXCEPTION_CONTINUE_SEARCH;

  time_t  nowtime;
  time(&nowtime);
  struct tm *pTime = localtime(&nowtime);
  char szFile[128] = { 0 };

  sprintf(szFile, "Alivc_Player_Demo_%4d_%02d_%02d_%02d_%02d_%02d.dmp", pTime->tm_year + 1900, pTime->tm_mon + 1, pTime->tm_mday, pTime->tm_hour, pTime->tm_min, pTime->tm_sec);
  HANDLE hFile = CreateFileA(szFile, GENERIC_READ | GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);

  if (hFile != INVALID_HANDLE_VALUE)
  {
    MINIDUMP_EXCEPTION_INFORMATION ExInfo;
    ExInfo.ThreadId = ::GetCurrentThreadId();
    ExInfo.ExceptionPointers = pExceptionInfo;
    ExInfo.ClientPointers = NULL;

    MINIDUMP_TYPE flags = (MINIDUMP_TYPE)(MiniDumpWithFullMemory | MiniDumpWithFullMemoryInfo | MiniDumpWithHandleData | MiniDumpWithUnloadedModules | MiniDumpWithThreadInfo);
    BOOL bOK = MiniDumpWriteDump(GetCurrentProcess(), GetCurrentProcessId(), hFile, flags, &ExInfo, NULL, NULL);
    ret = EXCEPTION_EXECUTE_HANDLER;
    CloseHandle(hFile);
  }

  return ret;
}

int main(int argc, char *argv[])
{
  //_CrtSetDbgFlag(_CRTDBG_ALLOC_MEM_DF|_CRTDBG_CHECK_ALWAYS_DF);

  //set crash dump handler
  signal(SIGABRT, signal_abort_handler);
  _set_abort_behavior(0, _WRITE_ABORT_MSG);
  SetUnhandledExceptionFilter(exception_handler);

  QApplication a(argc, argv);

  AlivcLivePlayerMainDlg playerDlg;
  playerDlg.setMinimumSize(1200, 600);
  QDesktopWidget *deskdop = QApplication::desktop();
  playerDlg.move((deskdop->width() - playerDlg.width()) / 2, (deskdop->height() - playerDlg.height()) / 2);
  playerDlg.show();

  return a.exec();
}
